<ui:composition
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:s="http://jboss.org/schema/seam/taglib"
        xmlns:g="http://www.ihe.net/gazelle"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="globalForm">
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <h1>#{pesManager.simulatedActor.name}</h1>
            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">#{pesManager.simulatedTransaction.name}</ui:define>
                <ui:include src="/fr/bp6Option.xhtml">
                    <ui:param name="isDisplayed"
                              value="#{pesManager.simulatedActor.keyword.equals('PES') and iti30Manager.isBp6Authorized()}"/>
                    <ui:param name="idsToRender" value="globalForm"/>
                </ui:include>
                <s:div id="sutDiv">
                    <s:decorate template="/configuration/initiatorFrame.xhtml">
                        <ui:param name="actorKeyword"
                                  value="#{pesManager.receivingActor.keyword}"/>
                        <ui:param name="diagramImg"
                                  value="diag/#{pesManager.selectedTriggerEvent}_#{pesManager.simulatedActor.keyword}.png"/>
                        <ui:param name="currentConfig" value="#{pesManager.selectedSUT}"/>
                        <ui:param name="simuFacility"
                                  value="#{pesManager.sendingFacility}"/>
                        <ui:param name="simuApplication"
                                  value="#{pesManager.sendingApplication}"/>
                        <ui:param name="sectionsToReRender" value="sendMessageButtonDiv"/>
                        <ui:param name="simulatorConfigurationName"
                                  value="#{pesManager.simulatedActor.name} #{messages['gazelle.PAMSimulator.Simulator']}"/>
                        <ui:param name="availableSuts" value="#{pesManager.availableSystems}"/>
                        <ui:define name="moreDetails">
                            <ui:include src="/cat/assigningAuthoritiesForSystem.xhtml">
                                <ui:param name="selectedSUT" value="#{pesManager.selectedSUT}"/>
                            </ui:include>
                        </ui:define>
                    </s:decorate>
                </s:div>
                <s:div id="mainPanel"
                       rendered="#{pesManager.hl7Messages == null}">
                    <s:div id="eventSelection">
                        <div class="row form-inline">
                            <ui:decorate template="/layout/form/_edit.xhtml">
                                <ui:define name="label">#{messages['gazelle.simulator.pam.CategoryOfEvent']}
                                </ui:define>
                                <ui:param name="id" value="eventSelectionMenu"/>
                                <h:selectOneMenu id="eventSelectionMenu" styleClass="form-control"
                                                 value="#{pesManager.selectedEvent}"
                                                 valueChangeListener="#{pesManager.eventChangeListener}">
                                    <s:selectItems value="#{pesManager.availableEvents}"
                                                   var="event" label="#{event.eventName}"/>
                                    <a4j:ajax render="@form" execute="@form"
                                              listener="#{facesContext.renderResponse}"/>
                                </h:selectOneMenu>
                            </ui:decorate>
                            <!-- Action (INSERT, CANCEL, UPDATE) selection -->
                            <ui:decorate template="/layout/form/_edit.xhtml">
                                <ui:define name="label">#{messages['gazelle.simulator.pam.ActionToPerform']}
                                </ui:define>
                                <ui:param name="id" value="actionSelectionMenu"/>
                                <h:selectOneMenu id="actionSelectionMenu" styleClass="form-control"
                                                 value="#{pesManager.selectedAction}"
                                                 valueChangeListener="#{pesManager.actionChangeListener}">
                                    <f:selectItems value="#{pesManager.availableActions}"/>
                                    <a4j:ajax render="@form" execute="@form"
                                              listener="#{facesContext.renderResponse}"/>
                                </h:selectOneMenu>
                            </ui:decorate>
                            <s:span rendered="#{pesManager.selectedTriggerEvent != null and (pesManager.selectedTriggerEvent.equals('A01') or pesManager.selectedTriggerEvent.equals('A04'))}">
                                <ui:decorate template="/layout/form/_checkbox.xhtml" id="confirmPreAdmitDiv">
                                    <h:selectBooleanCheckbox
                                            value="#{pesManager.confirmPreadmission}"
                                            valueChangeListener="#{pesManager.confirmPreadmissionListener}">
                                        <a4j:ajax render="@form" execute="@form"
                                                  listener="#{facesContext.renderResponse}"/>
                                    </h:selectBooleanCheckbox>
                                    #{messages['net.ihe.gazelle.pam.ConfirmAPreadmission']}
                                </ui:decorate>
                            </s:span>
                        </div>
                        <s:decorate template="/layout/form/_checkbox.xhtml"
                                    id="historicMovementOption"
                                    rendered="#{pesManager.selectedEvent != null and pesManager.selectedEvent.updateTriggerEvent != null}">
                            <h:selectBooleanCheckbox
                                    value="#{pesManager.historicMovementOption}"
                                    disabled="#{pesManager.isBP6Mode()}"/>
                            #{messages['gazelle.simulator.pam.HistoricMovementManagement']}
                            <h:outputText value="#{messages['gazelle.pam.SupportOfThisOptionIsRequiredInFrance']}"
                                          rendered="#{pesManager.isBP6Mode()}"
                                          styleClass="help-block"/>
                        </s:decorate>
                    </s:div>
                    <br/><br/>
                    <s:decorate template="/patient/messageConfigTemplate.xhtml"
                                rendered="#{pesManager.selectedEvent != null}">
                        <ui:param name="managedBean" value="#{pesManager}"/>
                        <ui:param name="allowPatientGeneration" value="false"/>
                        <ui:param name="renderedForSendMessageButton" value="#{pesManager.hl7Messages == null}"/>
                        <ui:define name="helpText">
                            <s:div rendered="#{pesManager.selectedAction.name.equals('INSERT') and pesManager.selectedPatient == null and pesManager.secondaryPatient == null and not (pesManager.selectedTriggerEvent.equals('A01') and pesManager.confirmPreadmission)}">
                                <a4j:commandButton value="#{messages['gazelle.pam.SelectAnExistingPatient']}"
                                                   rendered="#{pesManager.selectedEvent.selection.displayPatientButton() and not pesManager.displayPatientsList and not pesManager.displayDDSPanel}"
                                                   actionListener="#{pesManager.switchToSelectionMode()}"
                                                   styleClass="gzl-btn-blue" render="messageConfigurationPanel"/>
                                <a4j:commandButton value="#{messages['gazelle.pam.SelectAnExistingEncounter']}"
                                                   rendered="#{pesManager.selectedEvent.selection.displayEncounters() and pesManager.displayPatientsList}"
                                                   actionListener="#{pesManager.switchToEncounterSelectionMode()}"
                                                   styleClass="gzl-btn-blue" render="messageConfigurationPanel"/>
                                <a4j:commandButton value="#{messages['gazelle.pam.GenerateAPatient']}"
                                                   rendered="#{pesManager.selectedEvent.selection.displayPatientButton() and not pesManager.displayDDSPanel}"
                                                   actionListener="#{pesManager.switchToGenerationMode()}"
                                                   styleClass="gzl-btn-blue" render="messageConfigurationPanel"/>
                            </s:div>
                            <br/>
                        </ui:define>
                        <ui:define name="actionOnPatientColumn">
                            <g:column>
                                <f:facet name="header">#{messages['gazelle.pam.Actions']}</f:facet>
                                <div class="gzl-never-wrap">
                                    <h:outputLink value="#{patient.permanentLink}"
                                                  target="blank">
                                        <s:span styleClass="gzl-icon-search "/>
                                    </h:outputLink>
                                    <a4j:commandLink title="#{messages['gazelle.pam.SelectThisPatient']}"
                                                     actionListener="#{pesManager.selectPatient(patient)}"
                                                     render="messageConfigurationPanel"
                                                     rendered="#{not (pesManager.selectedTriggerEvent.equals('A08') or pesManager.selectedTriggerEvent.equals('A40') or pesManager.selectedTriggerEvent.equals('A44'))}">
                                        <s:span styleClass="gzl-icon-medkit "/>
                                    </a4j:commandLink>
                                    <a4j:commandLink title="#{messages['gazelle.pam.MarkAsCorrectPatient']}"
                                                     actionListener="#{pesManager.setSelectedPatient(patient)}"
                                                     render="messageConfigurationPanel"
                                                     rendered="#{pesManager.selectedTriggerEvent.equals('A40') or pesManager.selectedTriggerEvent.equals('A44')}">
                                        <s:span styleClass="gzl-icon-checked "/>
                                    </a4j:commandLink>
                                    <a4j:commandLink title="#{messages['gazelle.pam.MarkAsIncorrectPatient']}"
                                                     actionListener="#{pesManager.setSecondaryPatient(patient)}"
                                                     render="messageConfigurationPanel"
                                                     rendered="#{pesManager.selectedTriggerEvent.equals('A40')or pesManager.selectedTriggerEvent.equals('A44')}">
                                        <s:span styleClass="gzl-icon-times "/>
                                    </a4j:commandLink>
                                    <a4j:commandLink title="#{messages['gazelle.pam.UpdatePatientDemographics']}"
                                                     actionListener="#{pesManager.selectPatientForUpdate(patient)}"
                                                     render="messageConfigurationPanel"
                                                     rendered="#{pesManager.selectedTriggerEvent.equals('A08')}">
                                        <s:span styleClass="gzl-icon-pencil "/>
                                    </a4j:commandLink>
                                </div>
                            </g:column>
                        </ui:define>
                        <ui:define name="ddsButtons">
                            <a4j:commandButton value="#{messages['gazelle.simulator.pam.GenerateIncorrectPatient']}"
                                               actionListener="#{pesManager.generateIncorrectPatient()}"
                                               styleClass="gzl-btn-blue"
                                               render="messageConfigurationPanel"
                                               rendered="#{pesManager.selectedTriggerEvent.equals('A40') or pesManager.selectedTriggerEvent.equals('A44')}"/>
                            <a4j:commandButton value="#{messages['gazelle.simulator.pam.GenerateTargetPatient']}"
                                               actionListener="#{pesManager.generateSelectedPatient()}"
                                               styleClass="gzl-btn-blue"
                                               render="messageConfigurationPanel"
                                               rendered="#{pesManager.selectedTriggerEvent.equals('A40') or pesManager.selectedTriggerEvent.equals('A44')}"/>
                            <a4j:commandButton value="#{messages['gazelle.simulator.pam.GeneratePatient']}"
                                               actionListener="#{pesManager.generateSelectedPatient()}"
                                               styleClass="gzl-btn-blue"
                                               render="messageConfigurationPanel"
                                               rendered="#{not (pesManager.selectedTriggerEvent.equals('A40') or pesManager.selectedTriggerEvent.equals('A44'))}"/>
                        </ui:define>
                        <ui:define name="selectedPatient">
                            <f:subview id="viewForA08"
                                       rendered="#{pesManager.selectedTriggerEvent.equals('A08') and pesManager.secondaryPatient != null}">
                                <s:decorate template="/layout/panels/_panel_title_footer.xhtml"
                                            id="selectedPatient">
                                    <ui:define name="panel_title">
                                        #{messages['gazelle.simulator.pam.SelectedPatientForUpdate']}
                                    </ui:define>
                                    <ui:include src="/patient/editPatient.xhtml">
                                        <ui:param name="patient" value="#{pesManager.secondaryPatient}"/>
                                        <ui:param name="renderHistory" value="false"/>
                                        <ui:param name="renderEncounters" value="true"/>
                                        <ui:param name="renderZFD" value="#{pesManager.isBP6Mode()}"/>
                                        <ui:param name="zfp" value="#{pesManager.isBP6Mode()}"/>
                                        <ui:param name="allowPidMgmt" value="true"/>
                                        <ui:param name="managedBean" value="#{pesManager}"/>
                                        <ui:param name="renderRelationships" value="#{false}"/>
                                    </ui:include>
                                    <ui:define name="panel_footer">
                                        <a4j:commandButton
                                                value="#{messages['gazelle.simulator.pam.SelectAnotherPatient']}"
                                                actionListener="#{pesManager.resetPatientChoice()}"
                                                render="messageConfigurationPanel"
                                                styleClass="gzl-btn" immediate="true"/>
                                    </ui:define>
                                </s:decorate>
                            </f:subview>
                            <f:subview id="viewForA40"
                                       rendered="#{pesManager.selectedTriggerEvent.equals('A40') or pesManager.selectedTriggerEvent.equals('A44')}">
                                <ui:include src="/patient/_mergePatientsPanel.xhtml">
                                    <ui:param name="managedBean" value="#{pesManager}"/>
                                </ui:include>
                            </f:subview>
                            <f:subview id="displayPatientInfo"
                                       rendered="#{pesManager.selectedPatient != null and not (pesManager.selectedTriggerEvent.equals('A40') or pesManager.selectedTriggerEvent.equals('A44'))}">
                                <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                                    <ui:define name="panel_title">
                                        #{messages['gazelle.simulator.pam.SelectedPatient']}
                                    </ui:define>
                                    <s:div id="show"
                                           rendered="#{not pesManager.displayEditPatientPanel}">
                                        <ui:include src="/patient/showPatient.xhtml">
                                            <ui:param name="patient" value="#{pesManager.selectedPatient}"/>
                                            <ui:param name="renderHistory" value="false"/>
                                            <ui:param name="renderEncounters" value="false"/>
                                            <ui:param name="showLinks" value="false"/>
                                            <ui:param name="renderZFD" value="#{pesManager.isBP6Mode()}"/>
                                            <ui:param name="zfp" value="#{pesManager.isBP6Mode()}"/>
                                            <ui:param name="prefix" value="def"/>
                                            <ui:param name="renderRelationships" value="false"/>
                                            <ui:param name="zfs" value="false"/>
                                        </ui:include>
                                    </s:div>
                                    <s:div id="edit" rendered="#{pesManager.displayEditPatientPanel}">
                                        <ui:include src="/pds/editPatientWithIdManagement.xhtml">
                                            <ui:param name="patient"
                                                      value="#{pesManager.selectedPatient}"/>
                                            <ui:param name="renderHistory" value="false"/>
                                            <ui:param name="renderZFD" value="#{pesManager.isBP6Mode()}"/>
                                            <ui:param name="zfp" value="#{pesManager.isBP6Mode()}"/>
                                            <ui:param name="renderEncounters" value="false"/>
                                            <ui:param name="managedBean" value="#{pesManager}"/>
                                            <ui:param name="renderRelationships" value="#{false}"/>
                                        </ui:include>
                                    </s:div>
                                    <ui:define name="panel_footer">
                                        <a4j:commandButton value="#{messages['gazelle.pam.ChooseAnotherPatient']}"
                                                           actionListener="#{pesManager.resetPatientChoice()}"
                                                           render="messageConfigurationPanel"
                                                           styleClass="gzl-btn" immediate="true"/>
                                        <a4j:commandButton value="#{messages['gazelle.pam.EditPatientInformations']}"
                                                           actionListener="#{pesManager.setDisplayEditPatientPanel(true)}"
                                                           render="mainPanel" styleClass="gzl-btn-blue"
                                                           rendered="#{not pesManager.displayEditPatientPanel}"
                                                           immediate="true"/>
                                        <a4j:commandButton value="#{messages['gazelle.pam.ShowPatientInformations']}"
                                                           actionListener="#{pesManager.savePatient()}"
                                                           render="mainPanel" styleClass="gzl-btn-blue"
                                                           rendered="#{pesManager.displayEditPatientPanel}"/>
                                    </ui:define>
                                </ui:decorate>
                            </f:subview>
                        </ui:define>
                        <ui:define name="additionalPanels">
                            <s:div id="encounters"
                                   rendered="#{pesManager.selection.displayEncounters() and pesManager.selectedEncounter == null}">
                                <ui:include src="/pes/encounters.xhtml"/>
                            </s:div>
                            <s:div id="movements"
                                   rendered="#{pesManager.selection.displayMovements() and pesManager.selectedMovement == null}">
                                <ui:include src="/pes/movements.xhtml"/>
                            </s:div>
                            <s:div id="encounterEditPanel"
                                   rendered="#{pesManager.selectedEncounter != null}">
                                <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                                    <ui:define name="panel_title">#{messages['gazelle.simulator.pam.SelectedEncounter']}</ui:define>
                                    <f:subview id="newEncounterView"
                                               rendered="#{pesManager.selectedEncounter.id == null}">
                                        <ui:include src="/iti31/editEncounter.xhtml">
                                            <ui:param name="aEncounter" value="#{pesManager.selectedEncounter}"/>
                                            <ui:param name="aMovement" value="#{pesManager.selectedMovement}"/>
                                            <ui:param name="event" value="#{pesManager.selectedTriggerEvent}"/>
                                            <ui:param name="historic" value="#{pesManager.historicMovementOption}"/>
                                        </ui:include>
                                    </f:subview>
                                    <f:subview id="insertEncounterView"
                                               rendered="#{pesManager.selectedEncounter.id != null and not(pesManager.selectedTriggerEvent.equals('Z99'))}">
                                        <ui:include src="/pes/insertPanel.xhtml">
                                            <ui:param name="selectedEncounter" value="#{pesManager.selectedEncounter}"/>
                                            <ui:param name="selectedMovement" value="#{pesManager.selectedMovement}"/>
                                            <ui:param name="event" value="#{pesManager.selectedTriggerEvent}"/>
                                            <ui:param name="managedBean" value="#{pesManager}"/>
                                            <ui:param name="historic" value="#{pesManager.historicMovementOption}"/>
                                            <ui:param name="selectedPatient" value="#{pesManager.selectedPatient}"/>
                                        </ui:include>
                                    </f:subview>
                                    <f:subview id="updateMov"
                                               rendered="#{pesManager.selectedMovement != null and pesManager.selectedTriggerEvent.equals('Z99')}">
                                        <ui:include src="/pes/updateMovement.xhtml">
                                            <ui:param name="movement" value="#{pesManager.selectedMovement}"/>
                                            <ui:param name="encounter" value="#{pesManager.selectedEncounter}"/>
                                            <ui:param name="patient" value="#{pesManager.selectedEncounter.patient}"/>
                                            <ui:param name="managedBean" value="#{pesManager}"/>
                                            <ui:param name="historic" value="#{pesManager.historicMovementOption}"/>
                                        </ui:include>
                                    </f:subview>
                                    <ui:define name="panel_footer">
                                        <a4j:commandButton value="#{messages['gazelle.simulator.pam.RandomlyFillTheEncounter']}"
                                                           actionListener="#{pesManager.randomlyFillEncounter()}"
                                                           render="encounterEditPanel"
                                                           styleClass="gzl-btn-blue"
                                                           rendered="#{pesManager.selectedEncounter.id == null}"/>
                                        <a4j:commandButton value="#{messages['gazelle.pam.ResetChoice']}"
                                                           actionListener="#{pesManager.resetPatientChoice(null)}"
                                                           render="messageConfigurationPanel"
                                                           styleClass="gzl-btn" immediate="true"
                                                           rendered="#{pesManager.selectedEncounter.id != null}"/>
                                    </ui:define>
                                </ui:decorate>
                            </s:div>
                        </ui:define>
                    </s:decorate>
                </s:div>
                <s:decorate template="/layout/panels/_panel_title_footer_id.xhtml"
                            rendered="#{pesManager.hl7Messages != null}">
                    <ui:param name="panel_id" value="reportPanel"/>
                    <ui:define name="panel_title">#{messages['gazelle.simulator.pam.TestReport']}</ui:define>
                    <ui:include src="/messages/message_table.xhtml">
                        <ui:param name="hl7Messages" value="#{pesManager.hl7Messages}"/>
                    </ui:include>
                    <ui:define name="panel_footer">
                        <a4j:commandButton value="#{messages['gazelle.simulator.pam.PerformAnotherTest']}"
                                           styleClass="gzl-btn-blue"
                                           render="globalForm"
                                           actionListener="#{pesManager.performAnotherTest()}"/>
                    </ui:define>
                </s:decorate>
            </ui:decorate>
        </h:form>
        <h:form id="panelForm">
            <ui:include src="/iti31/cancelEventModalPanel.xhtml"/>
        </h:form>
    </ui:define>
</ui:composition>